var gsXMLData='';
var gsError='';
var gsAlerts='';
var gsXMLFetchDate='';
var gsXMLPublishDate='';
var gsFundClosingDate='';
var gsFundName = new Array();
var gsFundId = new Array();
var gsFundSharePrice = new Array();
var gsFundLastMonth = new Array();
var gsFundLast12Months = new Array();

gsFundName[0] = 'L 2040';
gsFundName[1] = 'L 2030';
gsFundName[2] = 'L 2020';
gsFundName[3] = 'L 2010';
gsFundName[4] = 'L Income';
gsFundName[5] = 'G';
gsFundName[6] = 'F';
gsFundName[7] = 'C';
gsFundName[8] = 'S';
gsFundName[9] = 'I';

gsFundId[0] = 'L 2040';
gsFundId[1] = 'L 2030';
gsFundId[2] = 'L 2020';
gsFundId[3] = 'L 2010';
gsFundId[4] = 'L Income';
gsFundId[5] = 'G Fund';
gsFundId[6] = 'F Fund';
gsFundId[7] = 'C Fund';
gsFundId[8] = 'S Fund';
gsFundId[9] = 'I Fund';

function Trim(sText)
{
	return sText.replace(/^\s+/g, '').replace(/\s+$/g, '');;
}

function getTimeStamp()
{
	var now = new Date();
	return (now.getFullYear() + '-' + (now.getMonth()+1) + '-' + now.getDate());
}

function getXMLField(sFieldTag, iStartIndex)
{

	iStart = gsXMLData.indexOf('<'+sFieldTag+'>',iStartIndex)+sFieldTag.length+2;
	iEnd   = gsXMLData.indexOf('</'+sFieldTag+'>',iStartIndex);
	if ((iStart < 0) || (iEnd < 0)) {
		return '';
	} else {
		return gsXMLData.substring(iStart, iEnd);
	}
}

function displayData ()
{

	if (gsError.length > 0) {
		status.data = gsError;
	} else if (gsAlerts.length > 0){
		status.data = gsAlerts;
	} else {
		status.data = 'Share price as of ' + gsFundClosingDate;
	}
	iRow = 0;
	for (i = 0; i < 10; i++){
		eval('bShowRow = (preferences.showfund_'+ i +'.value == "1");');
		if (bShowRow) {
			for (iCol = 0; iCol < 4; iCol++){
				eval('DataCell'+iRow+'0.data = gsFundName[i];');
				eval('DataCell'+iRow+'1.data = gsFundSharePrice[i];');
				eval('DataCell'+iRow+'2.data = gsFundLastMonth[i];');
				eval('DataCell'+iRow+'3.data = gsFundLast12Months[i];');
			}
			iRow++;
		}
	}
}

function fetchData()
{

	var objURL = new URL;

//	Clear current data
	gsError = '';
	gsAlerts = '';
	gsFundClosingDate = '';
	gsXMLPublishDate = '';
	gsXMLFetchDate = '';
	for (iRow = 0; iRow < 10; iRow++) {
		gsFundSharePrice[iRow] = '';
		gsFundLastMonth[iRow] = '';
		gsFundLast12Months[iRow] = '';
	} 

//	Retrieve XML feed
	objURL.location = 'http://www.andreaarevalo.com/tsp/tspxml.asp';
	gsXMLData = objURL.fetch();

//	Verify XML feed
	if ((gsXMLData.indexOf('<TSPTicker>') < 0) || (gsXMLData.indexOf('</TSPTicker>') < 0)) {
		gsError = 'Could not retrieve XML feed';
		return;
	}

//	Parse XML feed
	iStartIndex=0;
	iFundIndex = 0;
	for (iRow = 0; iRow < 10; iRow++) {
		iStartIndex = gsXMLData.toLowerCase().indexOf('<name>'+gsFundId[iRow].toLowerCase()+'</name>');
		if (iStartIndex >= 0) {
			gsFundSharePrice[iRow] = getXMLField('shareprice', iStartIndex);
			gsFundLastMonth[iRow] = getXMLField('lastmonth', iStartIndex);
			gsFundLast12Months[iRow] = getXMLField('last12months', iStartIndex);
		}
	}
	gsFundClosingDate = getXMLField('closingdate', 1);	
	gsXMLPublishDate = getXMLField('publishdate', 1);	
	gsXMLFetchDate = getTimeStamp();
	gsAlerts = Trim(getXMLField('alerts', 1));
}

function initWidget()
{
	for (iRow = 0; iRow < 10;iRow++){
		eval('preferences.showfund_'+iRow+'.title="' + gsFundName[iRow]+'";');
		for(iCol = 0; iCol < 4; iCol++){
			vOffset = 95 + iRow*15;
			switch(iCol){
				case 0:
					hOffset = 20;
					break;
				case 1:
					hOffset = 85;
					break;
				case 2:
					hOffset = 135;
					break;
				case 3:
					hOffset = 190;
					break;
			}
			eval('DataCell'+iRow+iCol+' = new Text();');
			eval('DataCell'+iRow+iCol+'.color = "#FFFFFF";');
			eval('DataCell'+iRow+iCol+'.font = "Helvetica Bold";');
			eval('DataCell'+iRow+iCol+'.size = 12;');
			eval('DataCell'+iRow+iCol+'.hOffset = '+hOffset+';');
			eval('DataCell'+iRow+iCol+'.vOffset = '+vOffset+';');
			eval('DataCell'+iRow+iCol+'.alignment = "left";');
		}
	}
	fetchData();
}

function initDisplay()
{
	suppressUpdates();
	var iVisibleRows = 0;
	for (i = 0; i < 10; i++){
		eval('if(preferences.showfund_'+ i +'.value == "1")iVisibleRows++;');
	}
	for (iRow = 0; iRow < 10;iRow++){
		for(iCol = 0; iCol < 4; iCol++){
			if(iRow < iVisibleRows){
				eval('DataCell'+iRow+iCol+'.opacity = 255;');
			} else {
				eval('DataCell'+iRow+iCol+'.opacity = 0;');
			}
		}
	}
	window_main.height = 50 + 45 + iVisibleRows * 15 + 25 + 25;
	frame_body.height = 45 + iVisibleRows*15 + 25;
	frame_footer.vOffset = frame_body.vOffset + frame_body.height;
	status.vOffset = frame_footer.vOffset-20;
	tspurl.vOffset = frame_footer.vOffset+5;
	frame_header.opacity = preferences.backgroundopacity.value*255/100;
	frame_body.opacity = preferences.backgroundopacity.value*255/100;
	frame_footer.opacity = preferences.backgroundopacity.value*255/100;
	resumeUpdates();
	displayData();
}

function refreshDisplay(bForceRefresh)
{
	if ((gsXMLFetchDate != getTimeStamp())||(bForceRefresh)){
		fetchData();
		displayData();
	}
}

initWidget();
initDisplay();